# BeatSaber-version-changer

## Base Config
The config file is the `config.yaml`. You can open it with any editor you want, I recommend `Visual Studio Code` or `Notepad++`.

First set your BeatSaber folder in the `beatsaberfolder`-variable or actually set it so, where Steam thinks where BeatSaber should be.
```yaml
beatsaberfolder: C:\\Program Files (x86)\\Steam\\steamapps\\common\\Beat Saber
```
Next rename your BeatSaber folder to something else, as example we will go with `Beat Saber-default`. 

To use our custom songs in every BeatSaber version we move the folder `custom_songs` from `BeatSaber-default/BeatSaber_data` to another location, in our example its `D:\\Games\\BeatSaber Songs`. The programm will ask to set the `custom_songs` folder everytime, when no `custom_songs` folder is in the `BeatSaber_data` folder. 
```yaml
beatsabersongs: D:\\Games\\BeatSaber Songs
```

## Add versions
To add a version to the version manager we have to add a version under the `versions` setting. Use spaces and not tabs to get the formatting done! Keep the `version:` and the section name the same, all letters have to be lowercase, just a-z0-9 and dots. Set the `path` where your custom beatsaber version is and set a name for it.
```yaml
versions:
  default:
    version: default
    path: C:\\Program Files (x86)\\Steam\\steamapps\\common\\Beat Saber-default
    name: Default, just change to this every time you done playing custom versions, so updates will  only deal with this version.
```

# Example configuration:
```yaml
beatsaberfolder: C:\\Program Files (x86)\\Steam\\steamapps\\common\\Beat Saber
beatsabersongs: D:\\Games\\BeatSaber Songs
versions:
  1.18.3:
    version: 1.18.3
    path: D:\Games\BeatSaber Online
    name: Multiplayer
  1.21.0:
    version: 1.21.0
    path: C:\\Program Files (x86)\\Steam\\steamapps\\common\\Beat Saber-Stream
    name: Stream
  1.22.0:
    version: 1.22.0
    path: C:\\Program Files (x86)\\Steam\\steamapps\\common\\Beat Saber-1.22.0
    name: Stream
  default:
    version: default
    path: C:\\Program Files (x86)\\Steam\\steamapps\\common\\Beat Saber-default
    name: Default, just change to this every time you done playing custom versions, so updates will  only deal with this version.

```